#ifndef _LIBMFILTER_
#define _LIBMFILTER_

#ifdef __cplusplus

#include "kalman/ekfilter.hpp"

class LibmFilter : public Kalman::EKFilter<double,1,false,true,false>{
public:
        LibmFilter();
		int Initialized;

protected:

        void makeBaseA();
        void makeBaseH();
        void makeBaseV();
        void makeBaseR();
        void makeBaseW();
        void makeBaseQ();
        
        void makeA();
        void makeH();
        void makeProcess();
        void makeMeasure();

        double Period, Mass, Gravity, Height;
};


#else
typedef struct LibmFilter LibmFilter;
#endif

void LibmFilter_init(LibmFilter *p, double *x0, double *P0);
void LibmFilter_step(LibmFilter *p, double *input, double *meas, double *est);

#endif