#ifndef BEN_COMMON_H
#define BEN_COMMON_H

#define LEFT	0
#define RIGHT	1

//#define USE_STATE_ESTIMATOR

extern "C"{
enum ContactStates {
	CONTACT_DSP=0,
	CONTACT_LSP,
	CONTACT_RSP,
	CONTACT_AIR,
	N_CONTACT_STATES
};


enum ControlStates{
	STATE_LAUNCH = 0,
	STATE_HOME,
	STATE_DOUBLESUPP,
	STATE_SHIFTLEFT,
	STATE_LIFTLEFT,
	STATE_STANDLEFT,
	STATE_STEPLEFT,
	STATE_TOUCHLEFT,
	STATE_SHIFTRIGHT,
	STATE_LIFTRIGHT,
	STATE_STANDRIGHT,
	STATE_STEPRIGHT,
	STATE_TOUCHRIGHT,

	N_CONTROL_STATES
};


#define N_J 12
#define N_U (N_J+6)
#define N_Q	(N_J+7)

//typedef struct FEATURES_t{
//	double state[N_Q+N_U];
//	double torque[N_J];
//
//	double com[3];
//	double comd[3];
//	double comdd[3];
//	double cop[3];
//	double foot[2][6];
//	double footd[2][6];
//	double footdd[2][6];
//	double torso[3];
//	double torsod[3];
//	double torsodd[3];
//	double cap[3];
//
//	double foot_force[2][6];
//} FEATURES_t;

typedef struct PRIMUS_t{

	double state[2*N_U+1];
	double state_est[2*N_U+1];
	double state_des[2*N_U+1];
	double torque[N_J];
	double torque_ff[N_J];

	double com[3];
	double comd[3];
	double comdd[3];
	double cop[3];
	double foot[2][6];
	double footd[2][6];
	double footdd[2][6];
	double torso[3];
	double torsod[3];
	double torsodd[3];
	double cap[3];

	double com_d[3];
	double comd_d[3];
	double comdd_d[3];
	double comdd_ff[3];
	double cop_d[3];
	double foot_d[2][6];
	double footd_d[2][6];
	double footdd_d[2][6];
	double torso_d[3];
	double torsod_d[3];
	double torsodd_d[3];
	double cap_d[3];

	double com_ik[3];
	double comd_ik[3];
	double foot_ik[2][6];
	double footd_ik[2][6];
	double torso_ik[3];
	double torsod_ik[3];
	double state_ik[2*N_U+1];
	double stated_ik[N_U];

	double com_raw[3];
	double comd_raw[3];
	double comdd_raw[3];
	double cop_raw[3];
	double foot_raw[2][6];
	double footd_raw[2][6];
	double footdd_raw[2][6];
	double torso_raw[3];
	double torsod_raw[3];
	double torsodd_raw[3];
	double cap_raw[3];

	double com_est[3];
	double comd_est[3];
	double foot_est[2][6];
	double cop_est[3];
	double com_force_est[3];
	double com_offset_est[3];

	double com_error[3];
	double cop_error[3];

	double comdd_d_raw[3];

	double angmom[3];
	double weight_dist;

	double time;
	double cstate_elapsed_time;
	double cstate_start_time;

	double foot_force[2][6];
	double foot_force_des[2][6];

	int controller_state;
	int contact_state;

	double step_des[4];
	double torso_torque[3];

	double task_force[3];
	double task_torque[3];

	double num_active_threads;

	double preview_cost;
	double preview_step_time;
	double preview_comp_time;

	double total_mass;


}PRIMUS_t;

}

#endif