% function humplot(filename)
% clear all; close all;

% if nargin<1
    filename = 'last';
% end
% filename = 'd02462';

if strcmp(filename,'last')
    fp = fopen('last_data');
    n = fscanf(fp,'%i');
    filename = sprintf('d%05i',n-1);
    fclose(fp);
end

[D,names,units,freq] = mrdplot_convert(filename);

D = D(1:end,:);

joint_order = {'L_HAA','L_HFE','L_KFE','L_AR','L_AFE','L_AAA','R_HAA','R_HFE','R_KFE','R_AR','R_AFE','R_AAA'};

N = size(D,1);
NJ = length(joint_order);
NU = 6 + NJ;
NQ = NU + 1;

T = D(:,1);
T = T - T(1);

% X = zeros(N,NQ+NU);
% X_D = zeros(N,NQ+NU);
% U = zeros(N,NJ);
% for i=1:NJ
%     X(:,6+i) = D(:,findname(names,sprintf('%s_th',joint_order{i})));
%     X_D(:,6+i) = D(:,findname(names,sprintf('%s_th_d',joint_order{i})));
%     X(:,NQ+6+i) = D(:,findname(names,sprintf('%s_thd',joint_order{i})));
%     X_D(:,NQ+6+i) = D(:,findname(names,sprintf('%s_thd_d',joint_order{i})));    
%     U(:,i) = D(:,findname(names,sprintf('%s_trq',joint_order{i})));
% end

X(:,1) = D(:,findname(names,'com_x'));
X(:,2) = D(:,findname(names,'com_y'));
X(:,3) = D(:,findname(names,'com_z'));

X(:,4) = D(:,findname(names,'comd_x'));
X(:,5) = D(:,findname(names,'comd_y'));
X(:,6) = D(:,findname(names,'comd_z'));

X_EST(:,1) = D(:,findname(names,'com_est_x'));
X_EST(:,2) = D(:,findname(names,'com_est_y'));
X_EST(:,3) = 0;

X_EST(:,4) = D(:,findname(names,'comd_est_x'));
X_EST(:,5) = D(:,findname(names,'comd_est_y'));
X_EST(:,6) = 0;

X_D(:,1) = D(:,findname(names,'com_x_d'));
X_D(:,2) = D(:,findname(names,'com_y_d'));
X_D(:,3) = D(:,findname(names,'com_z_d'));

X_D(:,4) = D(:,findname(names,'comd_x_d'));
X_D(:,5) = D(:,findname(names,'comd_y_d'));
X_D(:,6) = D(:,findname(names,'comd_z_d'));

COP(:,1) = D(:,findname(names,'cop_x'));
COP(:,2) = D(:,findname(names,'cop_y'));

COP_EST(:,1) = D(:,findname(names,'cop_est_x'));
COP_EST(:,2) = D(:,findname(names,'cop_est_y'));

COP_D(:,1) = D(:,findname(names,'cop_x_d'));
COP_D(:,2) = D(:,findname(names,'cop_y_d'));

CAP(:,1) = D(:,findname(names,'cap_x'));
CAP(:,2) = D(:,findname(names,'cap_y'));

STEP_D(:,1) = D(:,findname(names,'step_des_x'));
STEP_D(:,2) = D(:,findname(names,'step_des_y'));
STEP_D2(:,1) = D(:,findname(names,'step_des_2_x'));
STEP_D2(:,2) = D(:,findname(names,'step_des_2_y'));

FOOT(:,1) = D(:,findname(names,'l_foot_x'));
FOOT(:,2) = D(:,findname(names,'l_foot_y'));
FOOT(:,3) = D(:,findname(names,'l_foot_z'));
FOOT(:,4) = D(:,findname(names,'r_foot_x'));
FOOT(:,5) = D(:,findname(names,'r_foot_y'));
FOOT(:,6) = D(:,findname(names,'r_foot_z'));

FOOT_D(:,1) = D(:,findname(names,'l_foot_x_d'));
FOOT_D(:,2) = D(:,findname(names,'l_foot_y_d'));
FOOT_D(:,3) = D(:,findname(names,'l_foot_z_d'));
FOOT_D(:,4) = D(:,findname(names,'r_foot_x_d'));
FOOT_D(:,5) = D(:,findname(names,'r_foot_y_d'));
FOOT_D(:,6) = D(:,findname(names,'r_foot_z_d'));

FL = D(:,[findname(names,'l_foot_fx'),...
          findname(names,'l_foot_fy'),...
          findname(names,'l_foot_fz'),...
          findname(names,'l_foot_mx'),...
          findname(names,'l_foot_my'),...
          findname(names,'l_foot_mz')]);
FR = D(:,[findname(names,'r_foot_fx'),...
          findname(names,'r_foot_fy'),...
          findname(names,'r_foot_fz'),...
          findname(names,'r_foot_mx'),...
          findname(names,'r_foot_my'),...
          findname(names,'r_foot_mz')]);
FL_d = D(:,[findname(names,'l_foot_fx_d'),...
          findname(names,'l_foot_fy_d'),...
          findname(names,'l_foot_fz_d'),...
          findname(names,'l_foot_mx_d'),...
          findname(names,'l_foot_my_d'),...
          findname(names,'l_foot_mz_d')]);
FR_d = D(:,[findname(names,'r_foot_fx_d'),...
          findname(names,'r_foot_fy_d'),...
          findname(names,'r_foot_fz_d'),...
          findname(names,'r_foot_mx_d'),...
          findname(names,'r_foot_my_d'),...
          findname(names,'r_foot_mz_d')]);  

 
      
[b,a] = butter(2,10/500);

FL = filtfilt(b,a,FL);
FR = filtfilt(b,a,FR);
       
FONTSIZE = 12;
LINEWIDTH = 2;
FONTSIZE2 = 8;      

% figure(1);clf;
% subplot 311
% plot(T,X_D(:,1),'r--',T,X(:,1),'-',T,X_EST(:,1),'-.','LineWidth',LINEWIDTH);
% hold on;
% % plot(T,COP_D(:,1),'m--',T,COP(:,1),'c-','LineWidth',1);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('X-Position');
% title('COM Position/Velocity');
% subplot 312
% plot(T,X_D(:,2),'--',T,X(:,2),'-',T,X_EST(:,2),'-.','LineWidth',LINEWIDTH);
% hold on;
% % plot(T,COP_D(:,2),'m--',T,COP(:,2),'c-','LineWidth',1);
% % ylim([-0.02,0.03]);
% % axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Y-Position');
% subplot 313
% plot(T,X_D(:,4:5),'--',T,X(:,4:5),'-',T,X_EST(:,4:5),'-.','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Velocity');
% xlabel('time');

figure(2);clf;
plot(T,X(:,2),'r-',T,COP(:,2),'b--','LineWidth',3);
hold on;
% plot(T,X_D(:,5),'c-',T,X(:,5),'k--','LineWidth',LINEWIDTH);
% plot(T,COP_D(:,2),'m--',T,COP(:,2),'c-','LineWidth',1);
% plot(T,STEP_D(:,2),'k:');
% plot(T,FOOT(:,2),'m-',T,FOOT_D(:,2),'g--','LineWidth',LINEWIDTH);
% plot(T,FOOT(:,5),'m-',T,FOOT_D(:,5),'g--','LineWidth',LINEWIDTH);
% plot(T,STEP_D2(:,2),'b:');
axis tight;
xlabel('Time(s)');
ylabel('Y');
legend('COM-Y','COP-Y','STEP-Y-D','FOOT-Y','FOOT-Y-D','Location','SouthEast');

figure(1);clf;
plot(T,X(:,1),'r-',T,CAP(:,1),'b--','LineWidth',3);
hold on;
% plot(T,X_D(:,5),'c-',T,X(:,5),'k--','LineWidth',LINEWIDTH);
% plot(T,COP_D(:,2),'m--',T,COP(:,2),'c-','LineWidth',1);
plot(T,STEP_D(:,1),'k:');
plot(T,FOOT(:,1),'m-',T,FOOT_D(:,1),'g--','LineWidth',LINEWIDTH);
plot(T,FOOT(:,4),'m-',T,FOOT_D(:,4),'g--','LineWidth',LINEWIDTH);
% plot(T,STEP_D2(:,2),'b:');
axis tight;
xlabel('Time(s)');
ylabel('X');
legend('COM-X','CAP-X','STEP-X-D','FOOT-X','FOOT-X-D','Location','SouthEast');

% figure(2);clf;
% subplot(3,1,1);
% plot(T,[X(:,[1])],'b-',T,[X(:,[4])],'r-','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('State');
% legend('x-pos','x-vel');
% title('200N Forward Push Simulation');
% subplot(3,1,2);
% plot(T,[FL_d(:,[1])],'b-',T,[FL(:,[1])],'r-',T,[FR_d(:,[1])],'m--',T,[FR(:,[1])],'g--','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Force (N)');
% legend('F_L_X_-_L_i_B_M','F_L_X','F_R_X_-_L_i_B_M','F_R_X');
% subplot(3,1,3);
% plot(T,[FL_d(:,[5])],'b-',T,[FL(:,[5])],'r-',T,[FR_d(:,[5])],'m--',T,[FR(:,[5])],'g--','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Moment (Nm)');
% legend('M_L_Y_-_L_i_B_M','M_L_Y','M_R_Y_-_L_i_B_M','M_R_Y');
% xlabel('Time (s)');
% 
% figure(3);clf;
% subplot(3,1,1);
% plot(T,[X(:,[2])],'b-',T,[X(:,[5])],'r-','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('State');
% legend('y-pos','y-vel');
% title('300N Sideways Push');
% subplot(3,1,2);
% plot(T,[FL_d(:,[2])],'b--',T,[FL(:,[2])],'r-',T,[FR_d(:,[2])],'m--',T,[FR(:,[2])],'g-','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Force (N)');
% legend('F_L_Y_-_L_i_B_M','F_L_Y','F_R_Y_-_L_i_B_M','F_R_Y');
% subplot(3,1,3);
% plot(T,[FL_d(:,[4])],'b--',T,[FL(:,[4])],'r-',T,[FR_d(:,[4])],'m--',T,[FR(:,[4])],'g-','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Moment (Nm)');
% legend('M_L_X_-_L_i_B_M','M_L_X','M_R_X_-_L_i_B_M','M_R_X');
% xlabel('Time (s)');


% figure(4);
% subplot(4,1,1);
% plot(T,[X(:,[1])],'b-',T,[X(:,[4])],'r-','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('State');
% legend('x-pos','x-vel');
% title('250N Forward Push Simulation');
% subplot(4,1,2);
% plot(T,[FL_d(:,[1])],'b-',T,[FL(:,[1])],'r-',T,[FR_d(:,[1])],'m--',T,[FR(:,[1])],'g--','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Force (N)');
% % legend('F_L_X_-_L_i_B_M','F_L_X','F_R_X_-_L_i_B_M','F_R_X');
% % subplot(5,1,3);
% % plot(T,[FL_d(:,[2])],'b-',T,[FL(:,[2])],'r-',T,[FR_d(:,[2])],'m--',T,[FR(:,[2])],'g--','LineWidth',LINEWIDTH);
% % axis tight;
% % set(gca,'FontSize',FONTSIZE);
% % ylabel('Force (N)');
% % legend('F_L_Y_-_L_i_B_M','F_L_Y','F_R_Y_-_L_i_B_M','F_R_Y');
% subplot(4,1,3);
% plot(T,[COPL(:,[1])],'b-',T,[COPR(:,[1])],'r--',...
%      T,[COPL(:,[2])],'r-',T,[COPR(:,[2])],'g--','LineWidth',LINEWIDTH);
% ylim([-0.15,0.15]);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('COP (m)');
% % legend('COP_L_X','COP_R_X');
% subplot(4,1,4);
% plot(T,[EUL(:,[1])],'b-',T,[EUL(:,[2])],'m--','LineWidth',LINEWIDTH);
% axis tight;
% set(gca,'FontSize',FONTSIZE);
% ylabel('Torso Angle (rad)');
% xlabel('Time (s)');

% figure('Position',[1 1 600 800]);
% % px = X(:,1);
% % py = X(:,2);
% % zx = (FR(:,3).*(PR(:,1)+COPR(:,1)) + FL(:,3).*(PL(:,1)+COPL(:,1)))./(FR(:,3)+FL(:,3));
% % zy = (FR(:,3).*(PR(:,2)+COPR(:,2)) + FL(:,3).*(PL(:,2)+COPL(:,2)))./(FR(:,3)+FL(:,3));
% % 
% % plot(X_D(:,1),X_D(:,2),'b--','LineWidth',LINEWIDTH); hold on;
% 
% % subplot 411
% 
% plot(X(:,1),X(:,2),'r-','LineWidth',LINEWIDTH); 
% 
% hold on;
% 
% % STATE = D(:,findname(names,'state'))';
% % state = -1;
% dx = 0.1;
% dy = 0.05;
% % i=1;
% h = plot([PL(i,1)-dx,PL(i,1)+dx,PL(i,1)+dx,PL(i,1)-dx,PL(i,1)-dx]',...
%          [PL(i,2)-dy,PL(i,2)-dy,PL(i,2)+dy,PL(i,2)+dy,PL(i,2)-dy]','b-');
% h = plot([PR(i,1)-dx,PR(i,1)+dx,PR(i,1)+dx,PR(i,1)-dx,PR(i,1)-dx]',...
%          [PR(i,2)-dy,PR(i,2)-dy,PR(i,2)+dy,PR(i,2)+dy,PR(i,2)-dy]','b-');
% % for i=1:length(STATE)
% %     if (STATE(i) ~= state)
% %         if (state==2 && STATE(i)==4)
% %         h = plot([PL(i,1)-dx,PL(i,1)+dx,PL(i,1)+dx,PL(i,1)-dx,PL(i,1)-dx]',...
% %                  [PL(i,2)-dy,PL(i,2)-dy,PL(i,2)+dy,PL(i,2)+dy,PL(i,2)-dy]','b-');
% %         end
% %         
% %         if (state==3 && STATE(i)==4)
% %         h = plot([PR(i,1)-dx,PR(i,1)+dx,PR(i,1)+dx,PR(i,1)-dx,PR(i,1)-dx]',...
% %                  [PR(i,2)-dy,PR(i,2)-dy,PR(i,2)+dy,PR(i,2)+dy,PR(i,2)-dy]','b-');
% %         end
% %         state = STATE(i);
% %     end
% % end
% % legend('COM','ZMP','Location','Southeast');
% xlabel('x');
% ylabel('y');
% axis equal;
% % axis tight;

% figure('Position',[600 1 600 800]);
% 
% subplot 511
% plot(T,[FL_d(:,[1])],'b--',T,[FL(:,[1])],'r-',T,[FR_d(:,[1])],'m--',T,[FR(:,[1])],'g-','LineWidth',LINEWIDTH);
% ylabel('F_X');
% title('Walking Contact Forces');
% 
% subplot 512
% plot(T,[FL_d(:,[2])],'b--',T,[FL(:,[2])],'r-',T,[FR_d(:,[2])],'m--',T,[FR(:,[2])],'g-','LineWidth',LINEWIDTH);
% ylabel('F_Y');
% 
% subplot 513
% plot(T,[FL_d(:,[3])],'b--',T,[FL(:,[3])],'r-',T,[FR_d(:,[3])],'m--',T,[FR(:,[3])],'g-','LineWidth',LINEWIDTH);
% ylim([0,1000]);
% ylabel('F_Z');
% 
% subplot 514
% plot(T,[FL_d(:,[4])],'b--',T,[U(:,6)],'r-',T,[FR_d(:,[4])],'m--',T,[U(:,[12])],'g-','LineWidth',LINEWIDTH);
% ylabel('M_X');
% 
% subplot 515
% plot(T,[FL_d(:,[5])],'b--',T,[U(:,5)],'r-',T,[FR_d(:,[5])],'m--',T,[U(:,[11])],'g-','LineWidth',LINEWIDTH);
% ylabel('M_Y');
% 
% 
% figure('Position',[1 1 600 800]);
% for i=1:6
%     subplot(6,1,i);
%     plot(T,X_D(:,6+i),'b--',T,X(:,6+i),'r-',T,X_D(:,12+i),'m--',T,X(:,12+i),'g-','LineWidth',LINEWIDTH);
% end

% subplot 616
% plot(T,[FL_d(:,[6])],'b--',T,[FL(:,[6])],'r-',T,[FR_d(:,[6])],'m--',T,[FR(:,[6])],'g-','LineWidth',LINEWIDTH);
% ylabel('M_Y');

% ylim([0,1000]);
% plot(zxref,zyref,'k--');
% legend('COM','ZMP','Location','Southeast');
% plot(xf0,yf0,'go');
% plot(xf,yf,'go');
% plot(0.5*(xf0+xf),0.5*(yf0+yf),'go','LineWidth',3);
% 
% % zxref = Uc*xf0 + 0.5*U*(xf0+xf);
% % zyref = Uc*yf0 + 0.5*U*(yf0+yf);
% 
% h = plot([xf-dx,xf+dx,xf+dx,xf-dx,xf-dx]',[yf-dy,yf-dy,yf+dy,yf+dy,yf-dy]','m-');
