#ifndef PREVIEW0_H
#define PREVIEW0_H



#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/matrix_proxy.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/io.hpp>

using namespace boost::numeric::ublas;

//#define MAX_N	25

#ifdef __cplusplus
class Preview0{
public:

	Preview0(int N);
	double run(double *x, double L, double T, int N, double *traj, double *ttraj);

private:

	int MAX_N;
	int preview_initialized;

double gain_a;
double gain_b;
double gain_c;
double gain_d;

matrix<double>P;
matrix<double>Z;
matrix<double>UN;

double Qtrace;

void preview_recurse(matrix<double> *P, matrix<double> *Z, matrix<double> A, matrix<double> B, matrix<double> C, int i, int N);
void preview_init(matrix<double> *Q, matrix<double> *p, matrix<double> *Ain, matrix<double> *bin, double *x, double L, double T, int N);
void preview_update(matrix<double> *Q, matrix<double> *p, matrix<double> *Ain, matrix<double> *bin, double *x, double L, double T, int N);
void preview_simulate(double *x, double L, double T, int N, vector<double> u, double *traj, double *ttraj);
};
#else
typedef struct Preview2 Preview2;
#endif

#endif