#ifndef PREVIEW3_RECEDING_H
#define PREVIEW3_RECEDING_H



#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/matrix_proxy.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/io.hpp>

using namespace boost::numeric::ublas;

//#define MAX_N	25

#ifdef __cplusplus
class Preview3{
public:

	Preview3();
	double run(double *x, double L, double t, double T, int N, double Tstep, double Tdsp, double *step, double *traj);

private:

	int MAX_N;

int preview_initialized;

matrix<double>P;
matrix<double>Z;
matrix<double>UN;
matrix<double>U0;
matrix<double>U1;
matrix<double>U2;
matrix<double>U3;
matrix<double>U4;
matrix<double>U5;
matrix<double>U6;

double gain_a;
double gain_b;
double gain_c;
double gain_d;
double gain_ex;
double gain_ey;
double gain_f;

void preview_init(matrix<double> *Q, matrix<double> *p, matrix<double> *Ain, matrix<double> *bin, double *x, double L, double t, double T, int N, double Tstep, double Tdsp);
void preview_update(matrix<double> *Q, matrix<double> *p, matrix<double> *Ain, matrix<double> *bin, double *x, double L, double t, double T, int N, double Tstep, double Tdsp);
void preview_simulate(double *x, double L, double T, int N, vector<double> u, double *traj);

};
#else
typedef struct Preview3 Preview3;
#endif


#endif