#ifndef PREVIEW_COMMON
#define PREVIEW_COMMON

#include <windows.h>
#include <tchar.h>

enum PreviewTypes{
	PREVIEW0_RHC = 0,
	PREVIEW2_RHC,
	PREVIEW3_RHC,
	PREVIEW2_WALK_RHC,
	N_PREVIEW_TYPES
};

enum PreviewMsgTypes{
	PREVIEW_INPUT_WAITING = 1,
	PREVIEW_OUTPUT_WAITING,
	PREVIEW_INIT, 
	N_PREVIEW_MSG_TYPES
};



#define STEP_HEIGHT	0.05
#define STEP_TIME	0.4
#define STEP_T		0.1
#define STEP_N		16
#define STEP_DSP_T	0.1
#define LIFT_DELAY	0.05	// maximum time allowed to delay step
#define TOUCH_DELAY	0.05	// maximum time allowed to delay step
#define RHC_FREQ	30

#define PREVIEW0_RHC_DELAY	0.01
#define PREVIEW2_RHC_DELAY	0.04

#define MAX_THREADS	2

typedef struct{
	int msg_type;
	double x0[12];
	double t;
	double start_time;
	double traj[STEP_N][8];	// state traj
	double ttraj[STEP_N];	// time traj
	double step_des[2];	
	double step_time;
	double cost;
	double vdes[2];
	int type;
}preview_data_t;

typedef struct{
	preview_data_t data;
	int id;
} preview_t;


#define PREVIEW_MEM_SIZE sizeof(preview_data_t)

extern"C"{
	int preview_init(void);
	int preview_reinit(void);
	int preview_send(preview_data_t *data);
	int preview_recv(preview_data_t *data);

	//int preview_server_init(void);
}


#endif