#include "mex.h"
#include "preview.h"
      
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
	/*	INPUT: 
			x0 - state (10 x 1)
     *      L - height
     *      T - timestep
     *      N - number of timesteps
     *      Tstep - time of step
     *      Tdsp - time of step
		OUTPUT:		
			cost - cost of trajectory
     *      step - (2x1) location of footstep
     *      traj (Nx6)
	*/
    int i,N;
    double *cost;
	
	if(nrhs!=6) mexErrMsgTxt("preview_mex: Wrong number of input arguments");    
    
	if (mxGetM(prhs[0])!=10 && mxGetN(prhs[0])!=1){
        mexPrintf("should be %i x 1\n",8);
        mexErrMsgTxt("preview_mex: Wrong size of input argument 1"); 
    }
	if (mxGetM(prhs[1])!=1 || mxGetN(prhs[1])!=1){
        mexPrintf("should be 1 x 1\n");
        mexErrMsgTxt("preview_mex: Wrong size of input argument 2"); 
    }      

	if (mxGetM(prhs[2])!=1 || mxGetN(prhs[2])!=1){
        mexPrintf("should be 1 x 1\n");
        mexErrMsgTxt("preview_mex: Wrong size of input argument 3"); 
    }  
    
	if (mxGetM(prhs[3])!=1 || mxGetN(prhs[3])!=1){
        mexPrintf("should be 1 x 1\n");
        mexErrMsgTxt("preview_mex: Wrong size of input argument 4"); 
    }      
    
	if (mxGetM(prhs[4])!=1 || mxGetN(prhs[4])!=1){
        mexPrintf("should be 1 x 1\n");
        mexErrMsgTxt("preview_mex: Wrong size of input argument 5"); 
    }      
	if (mxGetM(prhs[5])!=1 || mxGetN(prhs[5])!=1){
        mexPrintf("should be 1 x 1\n");
        mexErrMsgTxt("preview_mex: Wrong size of input argument 6"); 
    }        
	if (nlhs>3)
        mexErrMsgTxt("preview_mex: Too many output arguments"); 
    
    N = (int)mxGetScalar(prhs[3]);
    

    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    plhs[1] = mxCreateDoubleMatrix(2,1,mxREAL);
    plhs[2] = mxCreateDoubleMatrix(6,N,mxREAL);
    
    cost = mxGetPr(plhs[0]);
      
    cost[0] = preview_control(mxGetPr(prhs[0]), mxGetScalar(prhs[1]), mxGetScalar(prhs[2]), N, mxGetScalar(prhs[4]), mxGetScalar(prhs[5]), mxGetPr(plhs[1]), mxGetPr(plhs[2]));
    
}
