#include "SDModel.h"
#include "SDModel_common.h"
#include "sdlib.h"
#include "primus_common.h"
#include "gsl_util.h"
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>

//static double right_offset[3] = {0.0525, -0.011, -0.05};      
//static double left_offset[3] = {0.0525, 0.011, -0.05};
//static double right_offset[3] = {0.0,0.0,0.0};      
//static double left_offset[3] = {0,0,0.0};
static double right_offset[3] = {-0.0032, 0.0, -0.0361};      
static double left_offset[3] = {-0.0032, 0.0, -0.0361};
static double hip_offset[3] = {0.0,0.0,0.0};

#define L_FOOT	7
#define R_FOOT	14

//void right_leg_fk(SDModel *m, double *q, double *xh, double *xf, double *Jh, double *Jf){
//	int i,j,k;
//	Primus *pc = new Primus(m);
//
//	for(i=0;i<m->NQ();i++)	pc->state[i] = q[i];
//
//	set_state(m,pc->state);
//
//	primus_feet(m,pc->PL,pc->JL,pc->PR,pc->JR);
//
//	for(i=0;i<6;i++){
//		xh[i] = -pc->PR[i];
//		xf[i] = pc->PL[i] - pc->PR[i];
//	}
//
//	sdtrans6(m, 0, xh, 33, xh);
//	sdtrans6(m, 0, xf, 33, xf);
//
//	if (Jh!=NULL && Jf!=NULL){
//		for(i=0;i<m->NU();i++){
//			for(j=0;j<6;j++){
//				k = 6*i+j;
//				Jh[k] = -pc->JR[k];
//				Jf[k] = pc->JL[k]-pc->JR[k];
//			}
//			sdtrans6(m, 0, &Jh[6*i], 33, &Jh[6*i]);
//			sdtrans6(m, 0, &Jf[6*i], 33, &Jf[6*i]);
//		}
//	}
//
//	delete pc;
//}
//
//
//void left_leg_fk(SDModel *m, double *q, double *xh, double *xf, double *Jh, double *Jf){
//	int i,j,k;
//	Primus *pc = new Primus(m);
//
//	for(i=0;i<m->NQ();i++)	pc->state[i] = q[i];
//
//	set_state(m,pc->state);
//
//	primus_feet(m,pc->PL,pc->JL,pc->PR,pc->JR);
//
//	for(i=0;i<6;i++){
//		xh[i] = -pc->PL[i];
//		xf[i] = pc->PR[i] - pc->PL[i];
//	}
//
//	sdtrans6(m, 0, xh, 26, xh);
//	sdtrans6(m, 0, xf, 26, xf);
//
//	if (Jh!=NULL && Jf!=NULL){
//		for(i=0;i<m->NU();i++){
//			for(j=0;j<6;j++){
//				k = 6*i+j;
//				Jh[k] = -pc->JL[k];
//				Jf[k] = pc->JR[k]-pc->JL[k];
//			}
//			sdtrans6(m, 0, &Jh[6*i], 26, &Jh[6*i]);
//			sdtrans6(m, 0, &Jf[6*i], 26, &Jf[6*i]);
//		}
//	}
//
//	delete pc;
//
//}


void primus_feet(SDModel *m, double *fL, double *JfL, double *fR, double *JfR){
    double temp[3];
    // calculate cof of left foot
    m->sdgetbtj(L_FOOT,temp);
    sdvadd(temp,left_offset,temp);
    body_position(m, NULL, L_FOOT, temp, fL, JfL);

    // calculate cof of right foot
    m->sdgetbtj(R_FOOT,temp);
    sdvadd(temp,right_offset,temp);
    body_position(m, NULL, R_FOOT, temp, fR, JfR);     
}

void primus_feet_Jdotdq(SDModel *m, double *x, double *JdotL, double *JdotR){
	int i,j,k;
	double *q = &x[0];
	double *dq = &x[m->NQ()];
	double temp1[6],temp2[6];
	double *lin1 = &temp1[0];
	double *rot1 = &temp1[3];
	double *lin2 = &temp2[0];
	double *rot2 = &temp2[3];
	
}

void primus_feetcorners(SDModel *m, double *fl, double *Jl, double *fr, double *Jr){
    double temp[3],temp2[3],temp3[3];
    double length = 0.25;
    double width = 0.12;
	double *lin;
    int i,j;    
    double offset[4][3] = {{length/2.0,width/2.0,0.0},
                           {length/2.0,-width/2.0,0.0},
                           {-length/2.0,-width/2.0,0.0},
                           {-length/2.0,width/2.0,0.0}};
    // calculate cof of left foot
    m->sdgetbtj(L_FOOT,temp);
    sdvadd(temp,left_offset,temp);
    for(i=0;i<4;i++){
        sdvadd(temp,offset[i],temp2);
		m->sdpos(L_FOOT,temp2,&fl[3*i]);
        // if (Jl!=NULL){
			// for(j=0;j<m->NU();j++){
				// lin = &Jl[3*4*i + 3*j]
				// m->sdrel2cart(i,L_FOOT,temp2,&Jl[6*i+0],temp3);
				// m->sdtrans(L_FOOT,lin,-1,lin);
			// }
		// }
    }

    // calculate cof of right foot
    m->sdgetbtj(R_FOOT,temp);
    sdvadd(temp,right_offset,temp);
    for(i=0;i<4;i++){
        sdvadd(temp,offset[i],temp2);
		m->sdpos(R_FOOT,temp2,&fr[3*i]);
        // if (Jl!=NULL){
			// for(j=0;j<m->NU();j++){
				// m->sdrel2cart(i,R_FOOT,temp2,&Jr[6*i+0],temp3);
				// m->sdtrans(R_FOOT,lin,-1,lin);
			// }
		// }
    }
}


void primus_com_wrt_feet(SDModel *m, double *cl, double *Jcl, double *cr, double *Jcr){
    double pl[6],pr[6];
    double temp[3];
    primus_feet(m, pl, NULL, pr, NULL);
    com_state(m,cl,NULL);
	sdvcopy(cl,cr);
	sdvsub(cl,pl,cl);
	sdvsub(cr,pr,cr);
	m->sdtrans(-1,cl,L_FOOT,cl);
	m->sdtrans(-1,cr,R_FOOT,cr);
}

//void primus_hose_contact(SDModel *m, double *p, double *J){
//	double temp[3];
//	double offset[3] = {-0.12,0.0,0.0};
//	double itj1[3],itj2[3];	
//	m->sdgetitj(13,itj1);
//	m->sdgetitj(20,itj2);
//	sdvadd(itj1,itj2,temp);
//	sdvaxpy(-0.5,temp,offset,temp);
//	body_position(m,NULL,0,temp,p,J);
//}


Primus::Primus(SDModel *model){
	int i;
	m = model;
	JL = new double[m->NU()*6];
	JR = new double[m->NU()*6];
	state = new double [m->NQ()+m->NU()];
	des_state = new double [m->NQ()+m->NU()];
	for(i=0;i<m->NQ()+m->NU();i++){
		state[i] = 0.0;
		des_state[i] = 0.0;
	}
	gsl_JL = gsl_matrix_view_array(JL,m->NU(),6);
	gsl_JR = gsl_matrix_view_array(JR,m->NU(),6);
	gsl_J = gsl_matrix_alloc(m->NU(),12);
}

Primus::~Primus(){
	delete JL;
	delete JR;
	delete state;
	delete des_state;
	gsl_matrix_free(gsl_J);
}


void primus_hip(SDModel *m, double *ph, double *Jh){
	body_position(m, NULL, 0, hip_offset, ph, Jh);     
}


void primus_forward_kinematics(SDModel *m,
							   double *state,
							   double *com,
							   double *pL,
							   double *pR,
							   double *T){
    double temp[6];
	set_state(m,state);
	primus_feet(m, pL, NULL, pR, NULL);
	primus_hip(m,temp,NULL);
#ifdef USE_HIP_AS_COM
	sdvcopy(&temp[0],com);
#else
	com_state(m,com,NULL);
#endif
	sdvcopy(&temp[3],&T[0]);	// torso rotation
}

//void primus_gravcomp(SDModel *m, double *X, double *U){
//	Primus *pr = new Primus(m);
//	gsl_matrix *QR = gsl_matrix_alloc(m->NU(),12);
//
//	primus_feet(m,pr->PL,pr->JL,pr->PR,pr->JR);
//	
//	gsl_matrix_horzcat(&pr->gsl_JL.matrix, &pr->gsl_JR.matrix, pr->gsl_J);
//
//	gsl_matrix_memcpy(QR,pr->gsl_J);
//
//	gsl_vector *tau = gsl_vector_alloc(12);
//	gsl_linalg_QR_decomp(QR,tau);
//
//	gsl_matrix *Q = gsl_matrix_alloc(m->NU(),m->NU());
//	gsl_matrix *R = gsl_matrix_alloc(m->NU(),12);
//	gsl_linalg_QR_unpack(QR,tau,Q,R);
//
//	set_state(m,X);
//
//	double *h = new double[m->NU()];
//	m->sdequivht(h);
//
//	gsl_vector_view hv = gsl_vector_view_array(h,m->NU());
//
//	gsl_matrix_view T = gsl_matrix_submatrix(Q,0,12,m->NU(),m->NU()-12);
//	gsl_vector *b = gsl_vector_alloc(m->NU()-12);
//
//	gsl_blas_dgemv(CblasTrans,-1.0,&T.matrix,&hv.vector,0.0,b);
//
//	gsl_matrix_view A = gsl_matrix_submatrix(&T.matrix,6,0,m->NU()-6,m->NU()-12);
//
//	gsl_matrix *AtA = gsl_matrix_alloc(m->NU()-12,m->NU()-12);
//	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,&A.matrix,&A.matrix,0.0,AtA);
//
//	gsl_permutation *p = gsl_permutation_alloc(m->NU()-12);
//	int signum;
//	gsl_linalg_LU_decomp(AtA,p,&signum);
//	gsl_linalg_LU_solve(AtA,p,b,b);
//
//	gsl_vector_view uv = gsl_vector_view_array(U,m->NU()-6);
//	gsl_blas_dgemv(CblasNoTrans,1.0,&A.matrix,b,0.0,&uv.vector);
//
//
//	delete pr;
//	gsl_matrix_free(QR);
//	gsl_vector_free( tau );
//	gsl_matrix_free( Q );
//	gsl_matrix_free( R );
//	delete h;
//	gsl_vector_free( b );
//	gsl_matrix_free( AtA );
//	gsl_permutation_free(p);
//}

void primus_com_ik(SDModel *m, double *state, double *pLd_des, double *pRd_des, double *dpdes, double *dTdes, double *dq){
	int i,j,k;
	//Primus *pr = new Primus(m);
	//double *Jp = new double[3*m->NU()];
	double fL[6],fR[6];	
	//double *state = new double[m->NQ()+m->NU()];

	gsl_matrix *J = gsl_matrix_calloc(m->NU(),12+6);
	gsl_matrix *A = gsl_matrix_calloc(12+6,12+6);
	gsl_vector *b = gsl_vector_calloc(12+6);

	gsl_matrix_view JL = gsl_matrix_submatrix(J,0,0,m->NU(),6);
	gsl_matrix_view JR = gsl_matrix_submatrix(J,0,6,m->NU(),6);
	gsl_matrix_view JP = gsl_matrix_submatrix(J,0,12,m->NU(),3);
	gsl_matrix_view JT = gsl_matrix_submatrix(J,0,15,m->NU(),3);

	//double *JLptr = gsl_matrix_ptr(&JL.matrix,0,0);
	//double *JRptr = gsl_matrix_ptr(&JR.matrix,0,0);
	//double *JPptr = gsl_matrix_ptr(&JP.matrix,0,0);

	double *JLd = new double [6*m->NU()];
	double *JRd = new double [6*m->NU()];
	double *JPd = new double [3*m->NU()];
	double *JTd = new double [3*m->NU()];

	for(i=0;i<3;i++)
		for(j=0;j<m->NU();j++)	JPd[3*j+i] = 0.0;

	gsl_matrix_view JLdv = gsl_matrix_view_array(JLd,m->NU(),6);
	gsl_matrix_view JRdv = gsl_matrix_view_array(JRd,m->NU(),6);
	gsl_matrix_view JPdv = gsl_matrix_view_array(JPd,m->NU(),3);
	gsl_matrix_view JTdv = gsl_matrix_view_array(JTd,m->NU(),3);

	//for(i=0;i<m->NQ();i++)		state[i] = q[i];
	//for(i=0;i<m->NU();i++)		state[m->NQ()+i] = 0.0;

	set_state(m,state);
	primus_feet(m, fL, JLd, fR, JRd);	
	com_jacobian(m,JPd);

	double zero[3]={0.0},lin[3],rot[3],offset[3]={0.0};
	for(i=0;i<m->NU();i++){
		m->sdrel2cart(i,0,offset,lin,rot);
		//m->sdtrans(0,lin,-1,lin);
		m->sdtrans(0,rot,-1,rot);
		//sdvcopy(lin,&JPd[3*i+0]);
		sdvcopy(rot,&JTd[3*i+0]);
	}

	//for(i=0;i<3;i++){
	//	for(j=0;j<m->NU();j++){
	//		printf("% f ",JPd[3*j+i]);
	//		//printf("% f ",gsl_matrix_get(&JPdv.matrix,j,i));
	//	}
	//	printf("\n");
	//}
	//printf("\n");

	gsl_matrix_memcpy(&JL.matrix,&JLdv.matrix);
	gsl_matrix_memcpy(&JR.matrix,&JRdv.matrix);
	gsl_matrix_memcpy(&JP.matrix,&JPdv.matrix);
	gsl_matrix_memcpy(&JT.matrix,&JTdv.matrix);

	//gsl_matrix_view AJv = gsl_matrix_submatrix(A,0,0,m->NU(),m->NU());
	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,J,J,0.0,A);

	for(i=0;i<12+6;i++)	gsl_matrix_set(A,i,i,gsl_matrix_get(A,i,i)+1.0e-3);

	gsl_vector_view dqv = gsl_vector_view_array(dq,m->NU());
	for(i=0;i<3;i++)	gsl_vector_set(b,i,pLd_des[i]);
	for(i=0;i<3;i++)	gsl_vector_set(b,6+i,pRd_des[i]);
	for(i=0;i<3;i++)	gsl_vector_set(b,12+i,dpdes[i]);
	for(i=0;i<3;i++)	gsl_vector_set(b,15+i,dTdes[i]);

	gsl_permutation *p = gsl_permutation_alloc(12+6);
	int signum;
	gsl_linalg_LU_decomp(A,p,&signum);
	gsl_linalg_LU_solve(A,p,b,b);

	gsl_blas_dgemv(CblasNoTrans,1.0,J,b,0.0,&dqv.vector);
	
	gsl_matrix_free(J);
	gsl_matrix_free(A);
	gsl_vector_free(b);
	gsl_permutation_free(p);
	//delete state;
	delete JLd;
	delete JRd;
	delete JPd;
	delete JTd;
}

