
#include "LibmFilter.h"

extern "C"{

#include "state_estimator.h"

static LibmFilter libmfilt;

void my_state_estimator( PRIMUS_t *s ){
	double u[2] = {0.0};
	double meas[4]={0.0};
	double xest[8]={0.0};
	static double offset[3]={0.0};
	static int last_controller_state = s->controller_state;

	if (!libmfilt.Initialized){
		double x0[8] = {s->com[0],0.0,s->com[0],0.0,s->com[1],0.0,s->com[1],0.0};
		double P0[8] = {0.01,0.01,0.01,0.01,0.01,0.01,0.01,0.01};
		LibmFilter_init(&libmfilt, x0, P0);
	}

	//if(s->controller_state!=last_controller_state){
	//	if (s->controller_state==DOUBLESUPP && ((last_controller_state==TOUCHRIGHT) || (last_controller_state==STEPRIGHT))){
	//		offset[0] += s->foot[LEFT][0] - s->foot[RIGHT][0];
	//		offset[1] += s->foot[LEFT][1] - s->foot[RIGHT][1];
	//	}
	//	if (s->controller_state==DOUBLESUPP && ((last_controller_state==TOUCHLEFT) || (last_controller_state==STEPLEFT))){
	//		offset[0] += s->foot[RIGHT][0] - s->foot[LEFT][0];
	//		offset[1] += s->foot[RIGHT][1] - s->foot[LEFT][1];
	//	}
	//}

	//switch (s->controller_state){
	//
	//	case SHIFTLEFT:
	//	case LIFTLEFT:
	//	case STEPLEFT:
	//	case TOUCHLEFT:
	//	case DOUBLESUPP:
	//		meas[0] = s->com[0] - s->foot[LEFT][0] + offset[0];
	//		meas[1] = s->cop[0] - s->foot[LEFT][0] + offset[0];
	//		meas[2] = s->com[1] - s->foot[LEFT][1] + offset[1];
	//		meas[3] = s->cop[1] - s->foot[LEFT][1] + offset[1];
	//		break;
	//	case SHIFTRIGHT:
	//	case LIFTRIGHT:
	//	case STEPRIGHT:
	//	case TOUCHRIGHT:
	//		meas[0] = s->com[0] - s->foot[RIGHT][0] + offset[0];
	//		meas[1] = s->cop[0] - s->foot[RIGHT][0] + offset[0];
	//		meas[2] = s->com[1] - s->foot[RIGHT][1] + offset[1];
	//		meas[3] = s->cop[1] - s->foot[RIGHT][1] + offset[1];
	//		break;
	//}

	//last_controller_state = s->controller_state;
	meas[0] = s->com[0];
	meas[1] = s->cop[0];
	meas[2] = s->com[1];
	meas[3] = s->cop[1];

	LibmFilter_step(&libmfilt, u, meas, xest);

	s->com_est[0] = xest[0];
	s->comd_est[0] = xest[1];
	s->cop_est[0] = xest[2];
	s->com_force_est[0] = xest[3]*s->total_mass;
	s->com_est[1] = xest[4];
	s->comd_est[1] = xest[5];
	s->cop_est[1] = xest[6];
	s->com_force_est[1] = xest[7]*s->total_mass;

}


}